package server;

import javax.ejb.MessageDriven;
import javax.jms.MessageListener;
import javax.jms.Message;
import javax.jms.JMSException;
import javax.jms.TextMessage;
import javax.annotation.*;

@MessageDriven(mappedName="jms/MDBQueue")
public class MDB implements MessageListener {

    public void onMessage(Message msg) {
        System.out.println("-- onMessage for instance " + thisInstanceNo + " got message! " + this);
        //Thread.dumpStack();
        long sleepSec = 0;
        try {
            sleepSec = msg.getIntProperty("sleepSec");
        } catch (JMSException ex) {
            ex.printStackTrace(); // trouble getting the "sleepSec" property...
        }
        try {
            System.out.println("--msg is: " + ((TextMessage)msg).getText());
            long SleepMs = sleepSec * 1000;
            System.out.println("--going to sleep for " + sleepSec + "s.: " + this);
            Thread.sleep(SleepMs);
            System.out.println("--woke up after sleeping: " + this);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static int idNo = 0;
    public int thisInstanceNo = ++idNo;

    public MDB() {
        System.out.println("-- Constructor instance " + thisInstanceNo + " called.");
    }

    @PostConstruct
    public void postConstr() {
        System.out.println("-- @PostConstruct instance " + thisInstanceNo + " called.");
    }

    @PreDestroy
    public void preDest() {
        System.out.println("-- @PreDestroy instance " + thisInstanceNo + " called.");
    }

    //public void finalize() {
    //    System.out.println("-- finalize instance " + thisInstanceNo + " called.");
    //}

}